#!/usr/bin/perl

$srpmsdir = "";
$rpms = "";
$comps = "";
$hdlist = "";


sub exec_ext_cmd {
  my($cmd, $path)=@_;
  my($ret);
  open(FOO, "$cmd $path|");
  $ret=<FOO>;
  chop $ret;
  close(FOO);
  $ret;
}

sub usage {
  print "\nUsage: chkdistrotree.pl --comps=COMPSXML [OPTION]\n\n";
  print "[OPTION]\n";
  print "--help           : this help message\n";
  print "--rpms           : specify rpm dir\n";
#  print "--srpms          : specify srpm dir\n";
#  print "--hdlist         : specify srpm dir\n";
}

sub parse_arguments
{
  local (@arglist) = @_;
  while (@arglist) {
    if($arglist[0] =~ /^--srpms=(.+)$/) {
      $srpmsdir = $1;
    } elsif($arglist[0] =~ /^--rpms=(.+)$/) {
      $rpms = $1;
    } elsif($arglist[0] =~ /^--comps=(.+)$/) {
      $comps = $1;
    } elsif($arglist[0] =~ /^--hdlist=(.+)$/) {
      $hdlist = $1;
    } elsif($arglist[0] =~ /^--help$/) {
      &usage;
      exit 0;
    }
    shift (@arglist);
  }
}

&parse_arguments(@ARGV);

if( ! $comps ) {
  print "Please specify comps file!\n";
  &usage;
  exit 1;
}

$listcompsfn = "/var/tmp/getlistfromcompsxml.$$";
$rc = system( "/usr/sbin/getlistfromcompsxml $comps > $listcompsfn");
if( $rc != 0 ) {
  print "Error: parsing $comps\n";
  system( "rm $listcompsfn");
  exit(1);
}

open( COMPS, "<$listcompsfn");
while(<COMPS>) {
  chop;
  $compslist{ $_ } = 1;
}
close(COMPS);


if( $rpms ) {
  open( RPMSDIR, "rpm -qp $rpms/*.rpm --queryformat \"%{NAME} %{VERSION} %{RELEASE}\\n\"|") or die "could not read pkgs on rpms dir\n";
  while(<RPMSDIR>) {
    chop;
    my($name, $ver, $rel ) = split;
    $rpmslist{ $name } = join(' ', $ver, $rel);
  }
  close(RPMSDIR);

  foreach my $i (keys %compslist) {
    if( $rpmslist{$i} eq "" ) {
      print "ONLYCOMPS: $i\n"; 
    }
  }
  foreach my $i (keys %rpmslist) {
    if( $compslist{$i} eq "" ) {
      print "ONLYRPMS: $i\n"; 
    }
  }
}





# system( "rm $listcompsfn");

exit 0;

